﻿using System;
using System.Net;
using System.Net.Sockets;
using System.Collections.Generic;
using System.Threading;

using JabboServerCMD.Core.Instances.User;

namespace JabboServerCMD.Core.Sockets
{
    public static class SocketServer
    {
        private static Socket socketHandler;
        private static int _Port;
        private static int _maxConnections;
        private static int _acceptedConnections;
        private static HashSet<int> _activeConnections;

        internal static bool Init(int bindPort, int maxConnections)
        {
            _Port = bindPort;
            _maxConnections = maxConnections;
            _activeConnections = new HashSet<int>();
            socketHandler = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            try
            {
                socketHandler.Bind(new IPEndPoint(IPAddress.Any, bindPort));
                socketHandler.Listen(Config.maxconnbacklog);
                socketHandler.BeginAccept(new AsyncCallback(connectionRequest), socketHandler);

                Console.WriteLine("    Sockets geïnitialiseerd, luisteren op poort: " + bindPort + ".");

                return true;
            }

            catch
            {
                return false;
            }
        }
        private static void connectionRequest(IAsyncResult iAr)
        {
            try
            {
                int connectionID = 0;
                for (int i = 1; i < _maxConnections; i++)
                {
                    if (_activeConnections.Contains(i) == false)
                    {
                        connectionID = i;
                        break;
                    }
                }

                if (connectionID > 0)
                {
                    Socket connectionSocket = ((Socket)iAr.AsyncState).EndAccept(iAr);
                    string ip = connectionSocket.RemoteEndPoint.ToString().Split(':')[0];
                    /*if (ip != "127.0.0.1")
                    {
                        Console.WriteLine("Attempted connection from {0}!", ip);
                        connectionSocket.Close();
                        socketHandler.BeginAccept(new AsyncCallback(connectionRequest), socketHandler);
                        return;
                    }*/
                    Config.Debug.WriteLine("[" + connectionID + "] New connection from " + ip);
                    _activeConnections.Add(connectionID);
                    _acceptedConnections++;
                    ConnectedUser newSocket = new ConnectedUser(connectionID, connectionSocket);
                }
            }
            catch { }
            socketHandler.BeginAccept(new AsyncCallback(connectionRequest), socketHandler);
        }
        internal static void freeConnection(int connectionID)
        {
            if (_activeConnections.Contains(connectionID))
            {
                _activeConnections.Remove(connectionID);
                Config.Debug.WriteLine("[" + connectionID + "] Flagged as free.");
            }
        }
        internal static int maxConnections
        {
            get
            {
                return _maxConnections;
            }
            set
            {
                _maxConnections = value;
            }
        }
        internal static int acceptedConnections
        {
            get { return _acceptedConnections; }
        }
    }
}
